<template>
  <el-form
    ref="formRef"
    v-loading="formLoading"
    :model="formData"
    :rules="formRules"
    label-width="80px"
  >
    <el-form-item label="资金类型" prop="type">
      <el-select v-model="formData.type" clearable placeholder="请选择资金申请类型">
        <el-option
          v-for="dict in getIntDictOptions(DICT_TYPE.BPM_FUND_APPLY_TYPE)"
          :key="dict.value"
          :label="dict.label"
          :value="dict.value"
        />
      </el-select>
    </el-form-item>
    <el-form-item label="申请时间" prop="startTime">
      <el-date-picker
        v-model="formData.startTime"
        clearable
        placeholder="请选择开始申请时间"
        type="datetime"
        value-format="x"
      />
<!--    </el-form-item>-->
<!--    <el-form-item label="结束时间" prop="endTime">-->
<!--      <el-date-picker-->
<!--        v-model="formData.endTime"-->
<!--        clearable-->
<!--        placeholder="请选择结束时间"-->
<!--        type="datetime"-->
<!--        value-format="x"-->
<!--      />-->
    </el-form-item>
    <el-form-item label="申请金额" prop="applyAmount">
      <el-input v-model="formData.applyAmount"  placeholder="请输申请金额" type="number" />
    </el-form-item>
    <el-form-item label="申请原因" prop="reason">
      <el-input v-model="formData.reason" placeholder="请输申请原因" type="textarea" />
    </el-form-item>
    <el-col v-if="startUserSelectTasks.length > 0">
      <el-card class="mb-10px">
        <template #header>指定审批人</template>
        <el-form
          :model="startUserSelectAssignees"
          :rules="startUserSelectAssigneesFormRules"
          ref="startUserSelectAssigneesFormRef"
        >
          <el-form-item
            v-for="userTask in startUserSelectTasks"
            :key="userTask.id"
            :label="`任务【${userTask.name}】`"
            :prop="userTask.id"
          >
            <el-select
              v-model="startUserSelectAssignees[userTask.id]"
              multiple
              placeholder="请选择审批人"
            >
              <el-option
                v-for="user in userList"
                :key="user.id"
                :label="user.nickname"
                :value="user.id"
              />
            </el-select>
          </el-form-item>
        </el-form>
      </el-card>
    </el-col>
    <el-form-item>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
    </el-form-item>
  </el-form>
</template>
<script lang="ts" setup>
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'
import * as FundApi from '@/api/bpm/fund'
import { useTagsViewStore } from '@/store/modules/tagsView'
import * as DefinitionApi from '@/api/bpm/definition'
import * as UserApi from '@/api/system/user'

defineOptions({ name: 'BpmFundApplyCreate' })

const message = useMessage() // 消息弹窗
const { delView } = useTagsViewStore() // 视图操作
const { push, currentRoute } = useRouter() // 路由

const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({
  type: undefined,
  reason: undefined,
  startTime: undefined,
  // endTime: undefined,
  applyAmount: undefined
})
const formRules = reactive({
  type: [{ required: true, message: '资金类型不能为空', trigger: 'blur' }],
  applyAmount: [{ required: true, message: '申请金额不能为空', trigger: 'change' }],
  reason: [{ required: true, message: '申请原因不能为空', trigger: 'change' }],
  startTime: [{ required: true, message: '申请时间不能为空', trigger: 'change' }],
  // endTime: [{ required: true, message: '申请结束时间不能为空', trigger: 'change' }]
})
const formRef = ref() // 表单 Ref

// 指定审批人
const processDefineKey = 'fund_apply' // 流程定义 Key
const startUserSelectTasks = ref([]) // 发起人需要选择审批人的用户任务列表
const startUserSelectAssignees = ref({}) // 发起人选择审批人的数据
const startUserSelectAssigneesFormRef = ref() // 发起人选择审批人的表单 Ref
const startUserSelectAssigneesFormRules = ref({}) // 发起人选择审批人的表单 Rules
const userList = ref<any[]>([]) // 用户列表

/** 提交表单 */
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 校验指定审批人
  if (startUserSelectTasks.value?.length > 0) {
    await startUserSelectAssigneesFormRef.value.validate()
  }

  // 提交请求
  formLoading.value = true
  try {
    const data = { ...formData.value } as unknown as FundApi.FundVO
    // 设置指定审批人
    if (startUserSelectTasks.value?.length > 0) {
      data.startUserSelectAssignees = startUserSelectAssignees.value
    }
    await FundApi.createFundApply(data)
    message.success('发起成功')
    // 关闭当前 Tab
    delView(unref(currentRoute))
    await push({ name: 'BpmFundApply' })
  } finally {
    formLoading.value = false
  }
}

/** 初始化 */
onMounted(async () => {
  const processDefinitionDetail = await DefinitionApi.getProcessDefinition(
    undefined,
    processDefineKey
  )
  if (!processDefinitionDetail) {
    message.error('资金申请的流程模型未配置，请检查！')
    return
  }
  startUserSelectTasks.value = processDefinitionDetail.startUserSelectTasks
  // 设置指定审批人
  if (startUserSelectTasks.value?.length > 0) {
    // 设置校验规则
    for (const userTask of startUserSelectTasks.value) {
      startUserSelectAssignees.value[userTask.id] = []
      startUserSelectAssigneesFormRules.value[userTask.id] = [
        { required: true, message: '请选择审批人', trigger: 'blur' }
      ]
    }
    // 加载用户列表
    userList.value = await UserApi.getSimpleUserList()
  }
})
</script>
